/*
 * MATLAB Compiler: 3.0
 * Date: Wed Aug 25 13:39:07 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-W" "main" "-L" "C"
 * "-t" "-T" "link:lib" "-h" "test_track" "libmmfile.mlib" "-v" 
 */
#include "extract_global_features_track.h"
#include "mwservices.h"
#include "compute_local_features_window.h"
#include "compute_windowed_fft.h"
#include "libmatlbm.h"
#include "libmmfile.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;
static mxArray * _mxarray2_;
static mxArray * _mxarray3_;
static mxArray * _mxarray4_;
static mxArray * _mxarray5_;

static mxChar _array7_[17] = { 'w', 'a', 'r', 'n', 'i', 'n', 'g', ' ', 'z',
                               'e', 'r', 'o', ' ', 'd', 'a', 't', 'a' };
static mxArray * _mxarray6_;
static mxArray * _mxarray8_;
static mxArray * _mxarray9_;
static mxArray * _mxarray10_;
static mxArray * _mxarray11_;
static mxArray * _mxarray12_;
static mxArray * _mxarray13_;
static mxArray * _mxarray14_;
static mxArray * _mxarray15_;
static mxArray * _mxarray16_;

void InitializeModule_extract_global_features_track(void) {
    _mxarray0_ = mclInitializeDouble(1.0);
    _mxarray1_ = mclInitializeDoubleVector(0, 0, (double *)NULL);
    _mxarray2_ = mclInitializeDouble(0.0);
    _mxarray3_ = mclInitializeDouble(2.0);
    _mxarray4_ = mclInitializeDouble(4.0);
    _mxarray5_ = mclInitializeDouble(138.0);
    _mxarray6_ = mclInitializeString(17, _array7_);
    _mxarray8_ = mclInitializeDouble(16.0);
    _mxarray9_ = mclInitializeDouble(17.0);
    _mxarray10_ = mclInitializeDouble(32.0);
    _mxarray11_ = mclInitializeDouble(.5);
    _mxarray12_ = mclInitializeDouble(.25);
    _mxarray13_ = mclInitializeDouble(.7);
    _mxarray14_ = mclInitializeDouble(.3);
    _mxarray15_ = mclInitializeDouble(3.0);
    _mxarray16_ = mclInitializeDouble(52.0);
}

void TerminateModule_extract_global_features_track(void) {
    mxDestroyArray(_mxarray16_);
    mxDestroyArray(_mxarray15_);
    mxDestroyArray(_mxarray14_);
    mxDestroyArray(_mxarray13_);
    mxDestroyArray(_mxarray12_);
    mxDestroyArray(_mxarray11_);
    mxDestroyArray(_mxarray10_);
    mxDestroyArray(_mxarray9_);
    mxDestroyArray(_mxarray8_);
    mxDestroyArray(_mxarray6_);
    mxDestroyArray(_mxarray5_);
    mxDestroyArray(_mxarray4_);
    mxDestroyArray(_mxarray3_);
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mextract_global_features_track(mxArray * * time_locations,
                                                mxArray * * data_locations,
                                                int nargout_,
                                                mxArray * data,
                                                mxArray * fft_params,
                                                mxArray * search_params);

_mexLocalFunctionTable _local_function_table_extract_global_features_track
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfExtract_global_features_track" contains the normal
 * interface for the "extract_global_features_track" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/extract_global_features_track.m"
 * (lines 1-147). This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
mxArray * mlfExtract_global_features_track(mxArray * * time_locations,
                                           mxArray * * data_locations,
                                           mxArray * data,
                                           mxArray * fft_params,
                                           mxArray * search_params) {
    int nargout = 1;
    mxArray * features = NULL;
    mxArray * time_locations__ = NULL;
    mxArray * data_locations__ = NULL;
    mlfEnterNewContext(
      2, 3, time_locations, data_locations, data, fft_params, search_params);
    if (time_locations != NULL) {
        ++nargout;
    }
    if (data_locations != NULL) {
        ++nargout;
    }
    features
      = Mextract_global_features_track(
          &time_locations__,
          &data_locations__,
          nargout,
          data,
          fft_params,
          search_params);
    mlfRestorePreviousContext(
      2, 3, time_locations, data_locations, data, fft_params, search_params);
    if (time_locations != NULL) {
        mclCopyOutputArg(time_locations, time_locations__);
    } else {
        mxDestroyArray(time_locations__);
    }
    if (data_locations != NULL) {
        mclCopyOutputArg(data_locations, data_locations__);
    } else {
        mxDestroyArray(data_locations__);
    }
    return mlfReturnValue(features);
}

/*
 * The function "mlxExtract_global_features_track" contains the feval interface
 * for the "extract_global_features_track" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/extract_global_features_track.m"
 * (lines 1-147). The feval function calls the implementation version of
 * extract_global_features_track through this function. This function processes
 * any input arguments and passes them to the implementation version of the
 * function, appearing above.
 */
void mlxExtract_global_features_track(int nlhs,
                                      mxArray * plhs[],
                                      int nrhs,
                                      mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[3];
    int i;
    if (nlhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: extract_global_features_track Line: 19 "
            "Column: 1 The function \"extract_global_features_track\" was "
            "called with more than the declared number of outputs (3)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: extract_global_features_track Line: 19"
            " Column: 1 The function \"extract_global_features_track\" wa"
            "s called with more than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 3; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0]
      = Mextract_global_features_track(
          &mplhs[1], &mplhs[2], nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 3 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 3; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mextract_global_features_track" is the implementation version
 * of the "extract_global_features_track" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/extract_global_features_track.m"
 * (lines 1-147). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * % fft_params.{fs, band_boundaries, window_size, overlapping_windows}
 * % search_params.{window_size (in fft coef), window_step}
 * % assume 16 bands
 * %   01 - 16: band_mean_t - mean power of each band over time
 * %   17 - 32: band_std_t - std power of each band over time
 * %   33 - 34: mpb - mean most powerful band of 4 , most powerful band of 16           
 * %   35:      mpb_std_t - std of most powerful band of 16
 * %   36:      band_width_50 - width of smallest set of bands containing 50 of power
 * %   37:      nsb_mean_t - mean of number of bands with greater than 25% power
 * %   38:      nsb_std_t - std of number of bands with greater than 25% power
 * %   39:      power_std - std of total power over time
 * %   40:      power_peaks - number of power peaks (below 30% to above 70%)
 * %   41:      periodicity - regularity of power peaks
 * %   42:      power range
 * %   43:      mean power
 * %   44 - 47: band_mean_t - reduced to 4 bands
 * %   48 - 51: band_std_t - reduced to 4 bands
 * %   52 - 138: time-dependent frequency information at different resolutions
 * function [features, time_locations, data_locations] = ...
 */
static mxArray * Mextract_global_features_track(mxArray * * time_locations,
                                                mxArray * * data_locations,
                                                int nargout_,
                                                mxArray * data,
                                                mxArray * fft_params,
                                                mxArray * search_params) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(
          &_local_function_table_extract_global_features_track);
    mxArray * features = NULL;
    mxArray * f = NULL;
    mxArray * peak_loc = NULL;
    mxArray * curr_state = NULL;
    mxArray * t = NULL;
    mxArray * had_high = NULL;
    mxArray * had_low = NULL;
    mxArray * power_30 = NULL;
    mxArray * power_70 = NULL;
    mxArray * max_power = NULL;
    mxArray * min_power = NULL;
    mxArray * num_bands_over_25 = NULL;
    mxArray * b = NULL;
    mxArray * width = NULL;
    mxArray * found = NULL;
    mxArray * total_pow = NULL;
    mxArray * band_pow = NULL;
    mxArray * mpb_4 = NULL;
    mxArray * mpb_16 = NULL;
    mxArray * tmp = NULL;
    mxArray * fft_pow = NULL;
    mxArray * coarse_fft_data = NULL;
    mxArray * ans = NULL;
    mxArray * fft_data = NULL;
    mxArray * i2 = NULL;
    mxArray * i1 = NULL;
    mxArray * w = NULL;
    mxArray * time_per_window = NULL;
    mxArray * first_window_time = NULL;
    mxArray * window_width_time = NULL;
    mxArray * num_windows = NULL;
    mxArray * track_length = NULL;
    mxArray * all_coarse_fft_data = NULL;
    mxArray * i = NULL;
    mxArray * all_fft_pow = NULL;
    mxArray * all_fft_data = NULL;
    mclCopyArray(&data);
    mclCopyArray(&fft_params);
    mclCopyArray(&search_params);
    /*
     * extract_global_features_track(data, fft_params, search_params)
     * 
     * 
     * % compute the wfft
     * % fft_data(num_bands, num_times)
     * all_fft_data = compute_windowed_fft(data, fft_params.fs, fft_params.band_boundaries, ...
     */
    mlfAssign(
      &all_fft_data,
      mclFeval(
        mclValueVarargout(),
        mlxCompute_windowed_fft,
        mclVa(data, "data"),
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".fs"),
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".band_boundaries"),
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".window_size"),
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".overlapping_windows"),
        NULL));
    /*
     * fft_params.window_size, fft_params.overlapping_windows);
     * 
     * all_fft_pow = sum(all_fft_data, 1);
     */
    mlfAssign(
      &all_fft_pow, mlfSum(mclVv(all_fft_data, "all_fft_data"), _mxarray0_));
    /*
     * for i = 1:size(all_fft_data, 2)
     */
    {
        int v_ = mclForIntStart(1);
        int e_
          = mclForIntEnd(
              mlfSize(
                mclValueVarargout(),
                mclVv(all_fft_data, "all_fft_data"),
                _mxarray3_));
        if (v_ > e_) {
            mlfAssign(&i, _mxarray1_);
        } else {
            /*
             * if all_fft_pow(i) ~= 0
             * all_fft_data(:, i) = all_fft_data(:, i) / all_fft_pow(i);            
             * end        
             * end
             */
            for (; ; ) {
                if (mclNeBool(
                      mclIntArrayRef1(mclVv(all_fft_pow, "all_fft_pow"), v_),
                      _mxarray2_)) {
                    mclArrayAssign2(
                      &all_fft_data,
                      mclMrdivide(
                        mclArrayRef2(
                          mclVv(all_fft_data, "all_fft_data"),
                          mlfCreateColonIndex(),
                          mlfScalar(v_)),
                        mclIntArrayRef1(mclVv(all_fft_pow, "all_fft_pow"), v_)),
                      mlfCreateColonIndex(),
                      mlfScalar(v_));
                }
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&i, mlfScalar(v_));
        }
    }
    /*
     * all_coarse_fft_data = zeros(4, size(all_fft_data, 2));
     */
    mlfAssign(
      &all_coarse_fft_data,
      mlfZeros(
        _mxarray4_,
        mlfSize(
          mclValueVarargout(), mclVv(all_fft_data, "all_fft_data"), _mxarray3_),
        NULL));
    /*
     * for i = 1:4
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = 4;
        if (v_ > e_) {
            mlfAssign(&i, _mxarray1_);
        } else {
            /*
             * all_coarse_fft_data(i, :) = sum(all_fft_data((i-1)*4+1:(i-1)*4+4, :), 1);
             * end
             */
            for (; ; ) {
                mclArrayAssign2(
                  &all_coarse_fft_data,
                  mlfSum(
                    mclArrayRef2(
                      mclVv(all_fft_data, "all_fft_data"),
                      mlfColon(
                        mlfScalar(
                          svDoubleScalarPlus(
                            svDoubleScalarTimes((double) (v_ - 1), 4.0), 1.0)),
                        mlfScalar(
                          svDoubleScalarPlus(
                            svDoubleScalarTimes((double) (v_ - 1), 4.0), 4.0)),
                        NULL),
                      mlfCreateColonIndex()),
                    _mxarray0_),
                  mlfScalar(v_),
                  mlfCreateColonIndex());
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&i, mlfScalar(v_));
        }
    }
    /*
     * 
     * track_length = size(all_fft_data, 2);    
     */
    mlfAssign(
      &track_length,
      mlfSize(
        mclValueVarargout(), mclVv(all_fft_data, "all_fft_data"), _mxarray3_));
    /*
     * num_windows = floor((track_length-search_params.window_size)/search_params.window_step);
     */
    mlfAssign(
      &num_windows,
      mlfFloor(
        mclFeval(
          mclValueVarargout(),
          mlxMrdivide,
          mclFeval(
            mclValueVarargout(),
            mlxMinus,
            mclVv(track_length, "track_length"),
            mlfIndexRef(mclVa(search_params, "search_params"), ".window_size"),
            NULL),
          mlfIndexRef(mclVa(search_params, "search_params"), ".window_step"),
          NULL)));
    /*
     * %disp(['num windows ' num2str(num_windows)]);
     * 
     * fft_params.window_step = fft_params.window_size/fft_params.overlapping_windows;
     */
    mlfIndexAssign(
      &fft_params,
      ".window_step",
      mclFeval(
        mclValueVarargout(),
        mlxMrdivide,
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".window_size"),
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".overlapping_windows"),
        NULL));
    /*
     * 
     * window_width_time = fft_params.window_size + fft_params.window_step*(search_params.window_size-1);
     */
    mlfAssign(
      &window_width_time,
      mclFeval(
        mclValueVarargout(),
        mlxPlus,
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".window_size"),
        mclFeval(
          mclValueVarargout(),
          mlxMtimes,
          mlfIndexRef(mclVa(fft_params, "fft_params"), ".window_step"),
          mclFeval(
            mclValueVarargout(),
            mlxMinus,
            mlfIndexRef(mclVa(search_params, "search_params"), ".window_size"),
            _mxarray0_,
            NULL),
          NULL),
        NULL));
    /*
     * first_window_time = window_width_time/2/fft_params.fs;            
     */
    mlfAssign(
      &first_window_time,
      mclFeval(
        mclValueVarargout(),
        mlxMrdivide,
        mclMrdivide(mclVv(window_width_time, "window_width_time"), _mxarray3_),
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".fs"),
        NULL));
    /*
     * time_per_window = fft_params.window_step*search_params.window_step/fft_params.fs;
     */
    mlfAssign(
      &time_per_window,
      mclFeval(
        mclValueVarargout(),
        mlxMrdivide,
        mclFeval(
          mclValueVarargout(),
          mlxMtimes,
          mlfIndexRef(mclVa(fft_params, "fft_params"), ".window_step"),
          mlfIndexRef(mclVa(search_params, "search_params"), ".window_step"),
          NULL),
        mlfIndexRef(mclVa(fft_params, "fft_params"), ".fs"),
        NULL));
    /*
     * 
     * features = zeros(138, num_windows);
     */
    mlfAssign(
      &features, mlfZeros(_mxarray5_, mclVv(num_windows, "num_windows"), NULL));
    /*
     * time_locations = zeros(num_windows, 1);
     */
    mlfAssign(
      time_locations,
      mlfZeros(mclVv(num_windows, "num_windows"), _mxarray0_, NULL));
    /*
     * data_locations = zeros(num_windows, 2);
     */
    mlfAssign(
      data_locations,
      mlfZeros(mclVv(num_windows, "num_windows"), _mxarray3_, NULL));
    /*
     * 
     * for w = 1:num_windows
     */
    {
        int v_ = mclForIntStart(1);
        int e_ = mclForIntEnd(mclVv(num_windows, "num_windows"));
        if (v_ > e_) {
            mlfAssign(&w, _mxarray1_);
        } else {
            /*
             * i1 = (w-1)*search_params.window_step+1;
             * i2 = i1 + search_params.window_size;
             * fft_data = all_fft_data(:, i1:i2);
             * if max(max(fft_data)) == 0
             * disp('warning zero data');
             * end
             * coarse_fft_data = all_coarse_fft_data(:, i1:i2);                
             * fft_pow = all_fft_pow(i1:i2);
             * time_locations(w) = first_window_time + (w-1)*time_per_window;
             * data_locations(w, :) = floor([(i1-1)*fft_params.window_step+1  ...
             * (i2-1)*fft_params.window_step+fft_params.window_size]);
             * 
             * % mean and std power
             * features(1:16, w) = mean(fft_data, 2);
             * features(17:32, w) = std(fft_data, 0, 2);
             * 
             * % most powerful band (perhaps should change mean to mode)
             * [tmp, mpb_16] = max(fft_data, [], 1);
             * mpb_4 = mpb_16/4;
             * features(33, w) = ceil(mean(mpb_4));
             * features(34, w) = round(mean(mpb_16));
             * features(35, w) = std(mpb_16);
             * 
             * % band width
             * band_pow = sum(fft_data, 2);
             * total_pow = sum(band_pow);
             * found = 0;
             * for width = 1:16
             * for b = 1:16-width+1
             * if sum(band_pow(b:b+width-1)/total_pow) > 0.5
             * found = 1;                
             * break;
             * end
             * end
             * if found
             * features(36) = width;
             * break;
             * end
             * end
             * 
             * % bands over 25% power
             * num_bands_over_25 = sum(fft_data > 0.25, 1);
             * features(37, w) = mean(num_bands_over_25);
             * features(38, w) = std(num_bands_over_25);
             * 
             * % std power
             * features(39, w) = std(fft_pow);
             * 
             * % power peaks
             * min_power = min(fft_pow);
             * max_power = max(fft_pow);
             * power_70 = 0.7*(max_power-min_power)+min_power;
             * power_30 = 0.3*(max_power-min_power)+min_power;    
             * had_low = 1;
             * had_high = 0;        
             * for t = 1:length(fft_pow)
             * curr_state = (fft_pow(t) > power_30) + (fft_pow(t) > power_70);
             * if curr_state < 1
             * had_low = 1;
             * had_high = 0;
             * elseif curr_state > 1
             * had_high = 1;
             * if had_low
             * had_low = 0;
             * features(40, w) = features(40, w) + 1;
             * peak_loc(features(40, w)) = t;
             * end
             * end
             * end        
             * 
             * if features(40, w) > 1        
             * features(41, w) = mean(peak_loc(2:end)-peak_loc(1:end-1));
             * features(41, w) = mean(abs((peak_loc(2:end)-peak_loc(1:end-1))-features(41, w)));        
             * else
             * features(41, w) = length(fft_pow)/4;
             * end
             * features(42, w) = max_power-min_power;
             * features(43, w) = mean(fft_pow);
             * 
             * % coarser resolution frequencies
             * for f = 44:47
             * i1 = (f-44)*4+1;
             * i2 = i1+3;
             * features(f, w) = mean(coarse_fft_data(f-43, :));
             * features(f+4, w) = std(coarse_fft_data(f-43, :));
             * end   
             * 
             * features(52:138, w) = compute_local_features_window(fft_data, fft_pow);    
             * 
             * end
             */
            for (; ; ) {
                mlfAssign(
                  &i1,
                  mclPlus(
                    mclFeval(
                      mclValueVarargout(),
                      mlxMtimes,
                      mlfScalar(v_ - 1),
                      mlfIndexRef(
                        mclVa(search_params, "search_params"), ".window_step"),
                      NULL),
                    _mxarray0_));
                mlfAssign(
                  &i2,
                  mclFeval(
                    mclValueVarargout(),
                    mlxPlus,
                    mclVv(i1, "i1"),
                    mlfIndexRef(
                      mclVa(search_params, "search_params"), ".window_size"),
                    NULL));
                mlfAssign(
                  &fft_data,
                  mclArrayRef2(
                    mclVv(all_fft_data, "all_fft_data"),
                    mlfCreateColonIndex(),
                    mlfColon(mclVv(i1, "i1"), mclVv(i2, "i2"), NULL)));
                if (mclEqBool(
                      mlfMax(
                        NULL,
                        mlfMax(NULL, mclVv(fft_data, "fft_data"), NULL, NULL),
                        NULL,
                        NULL),
                      _mxarray2_)) {
                    mlfDisp(_mxarray6_);
                }
                mlfAssign(
                  &coarse_fft_data,
                  mclArrayRef2(
                    mclVv(all_coarse_fft_data, "all_coarse_fft_data"),
                    mlfCreateColonIndex(),
                    mlfColon(mclVv(i1, "i1"), mclVv(i2, "i2"), NULL)));
                mlfAssign(
                  &fft_pow,
                  mclArrayRef1(
                    mclVv(all_fft_pow, "all_fft_pow"),
                    mlfColon(mclVv(i1, "i1"), mclVv(i2, "i2"), NULL)));
                mclIntArrayAssign1(
                  time_locations,
                  mclPlus(
                    mclVv(first_window_time, "first_window_time"),
                    mclMtimes(
                      mlfScalar(v_ - 1),
                      mclVv(time_per_window, "time_per_window"))),
                  v_);
                mclArrayAssign2(
                  data_locations,
                  mlfFloor(
                    mlfHorzcat(
                      mclPlus(
                        mclFeval(
                          mclValueVarargout(),
                          mlxMtimes,
                          mclMinus(mclVv(i1, "i1"), _mxarray0_),
                          mlfIndexRef(
                            mclVa(fft_params, "fft_params"), ".window_step"),
                          NULL),
                        _mxarray0_),
                      mclFeval(
                        mclValueVarargout(),
                        mlxPlus,
                        mclFeval(
                          mclValueVarargout(),
                          mlxMtimes,
                          mclMinus(mclVv(i2, "i2"), _mxarray0_),
                          mlfIndexRef(
                            mclVa(fft_params, "fft_params"), ".window_step"),
                          NULL),
                        mlfIndexRef(
                          mclVa(fft_params, "fft_params"), ".window_size"),
                        NULL),
                      NULL)),
                  mlfScalar(v_),
                  mlfCreateColonIndex());
                mclArrayAssign2(
                  &features,
                  mlfMean(mclVv(fft_data, "fft_data"), _mxarray3_),
                  mlfColon(_mxarray0_, _mxarray8_, NULL),
                  mlfScalar(v_));
                mclArrayAssign2(
                  &features,
                  mlfStd(mclVv(fft_data, "fft_data"), _mxarray2_, _mxarray3_),
                  mlfColon(_mxarray9_, _mxarray10_, NULL),
                  mlfScalar(v_));
                mlfAssign(
                  &tmp,
                  mlfMax(
                    &mpb_16,
                    mclVv(fft_data, "fft_data"),
                    _mxarray1_,
                    _mxarray0_));
                mlfAssign(
                  &mpb_4, mclMrdivide(mclVv(mpb_16, "mpb_16"), _mxarray4_));
                mclIntArrayAssign2(
                  &features,
                  mlfCeil(mlfMean(mclVv(mpb_4, "mpb_4"), NULL)),
                  33,
                  v_);
                mclIntArrayAssign2(
                  &features,
                  mlfRound(mlfMean(mclVv(mpb_16, "mpb_16"), NULL)),
                  34,
                  v_);
                mclIntArrayAssign2(
                  &features,
                  mlfStd(mclVv(mpb_16, "mpb_16"), NULL, NULL),
                  35,
                  v_);
                mlfAssign(
                  &band_pow, mlfSum(mclVv(fft_data, "fft_data"), _mxarray3_));
                mlfAssign(
                  &total_pow, mlfSum(mclVv(band_pow, "band_pow"), NULL));
                mlfAssign(&found, _mxarray2_);
                {
                    int v_0 = mclForIntStart(1);
                    int e_0 = 16;
                    if (v_0 > e_0) {
                        mlfAssign(&width, _mxarray1_);
                    } else {
                        for (; ; ) {
                            int v_1 = mclForIntStart(1);
                            int e_1 = 16 - v_0 + 1;
                            if (v_1 > e_1) {
                                mlfAssign(&b, _mxarray1_);
                            } else {
                                for (; ; ) {
                                    if (mclGtBool(
                                          mlfSum(
                                            mclMrdivide(
                                              mclArrayRef1(
                                                mclVv(band_pow, "band_pow"),
                                                mlfColon(
                                                  mlfScalar(v_1),
                                                  mlfScalar(v_1 + v_0 - 1),
                                                  NULL)),
                                              mclVv(total_pow, "total_pow")),
                                            NULL),
                                          _mxarray11_)) {
                                        mlfAssign(&found, _mxarray0_);
                                        break;
                                    }
                                    if (v_1 == e_1) {
                                        break;
                                    }
                                    ++v_1;
                                }
                                mlfAssign(&b, mlfScalar(v_1));
                            }
                            if (mlfTobool(mclVv(found, "found"))) {
                                mclIntArrayAssign1(
                                  &features, mlfScalar(v_0), 36);
                                break;
                            }
                            if (v_0 == e_0) {
                                break;
                            }
                            ++v_0;
                        }
                        mlfAssign(&width, mlfScalar(v_0));
                    }
                }
                mlfAssign(
                  &num_bands_over_25,
                  mlfSum(
                    mclGt(mclVv(fft_data, "fft_data"), _mxarray12_),
                    _mxarray0_));
                mclIntArrayAssign2(
                  &features,
                  mlfMean(mclVv(num_bands_over_25, "num_bands_over_25"), NULL),
                  37,
                  v_);
                mclIntArrayAssign2(
                  &features,
                  mlfStd(
                    mclVv(num_bands_over_25, "num_bands_over_25"), NULL, NULL),
                  38,
                  v_);
                mclIntArrayAssign2(
                  &features,
                  mlfStd(mclVv(fft_pow, "fft_pow"), NULL, NULL),
                  39,
                  v_);
                mlfAssign(
                  &min_power,
                  mlfMin(NULL, mclVv(fft_pow, "fft_pow"), NULL, NULL));
                mlfAssign(
                  &max_power,
                  mlfMax(NULL, mclVv(fft_pow, "fft_pow"), NULL, NULL));
                mlfAssign(
                  &power_70,
                  mclPlus(
                    mclMtimes(
                      _mxarray13_,
                      mclMinus(
                        mclVv(max_power, "max_power"),
                        mclVv(min_power, "min_power"))),
                    mclVv(min_power, "min_power")));
                mlfAssign(
                  &power_30,
                  mclPlus(
                    mclMtimes(
                      _mxarray14_,
                      mclMinus(
                        mclVv(max_power, "max_power"),
                        mclVv(min_power, "min_power"))),
                    mclVv(min_power, "min_power")));
                mlfAssign(&had_low, _mxarray0_);
                mlfAssign(&had_high, _mxarray2_);
                {
                    int v_2 = mclForIntStart(1);
                    int e_2 = mclLengthInt(mclVv(fft_pow, "fft_pow"));
                    if (v_2 > e_2) {
                        mlfAssign(&t, _mxarray1_);
                    } else {
                        for (; ; ) {
                            mlfAssign(
                              &curr_state,
                              mclPlus(
                                mclGt(
                                  mclIntArrayRef1(
                                    mclVv(fft_pow, "fft_pow"), v_2),
                                  mclVv(power_30, "power_30")),
                                mclGt(
                                  mclIntArrayRef1(
                                    mclVv(fft_pow, "fft_pow"), v_2),
                                  mclVv(power_70, "power_70"))));
                            if (mclLtBool(
                                  mclVv(curr_state, "curr_state"),
                                  _mxarray0_)) {
                                mlfAssign(&had_low, _mxarray0_);
                                mlfAssign(&had_high, _mxarray2_);
                            } else if (mclGtBool(
                                         mclVv(curr_state, "curr_state"),
                                         _mxarray0_)) {
                                mlfAssign(&had_high, _mxarray0_);
                                if (mlfTobool(mclVv(had_low, "had_low"))) {
                                    mlfAssign(&had_low, _mxarray2_);
                                    mclIntArrayAssign2(
                                      &features,
                                      mclPlus(
                                        mclIntArrayRef2(
                                          mclVv(features, "features"), 40, v_),
                                        _mxarray0_),
                                      40,
                                      v_);
                                    mclArrayAssign1(
                                      &peak_loc,
                                      mlfScalar(v_2),
                                      mclIntArrayRef2(
                                        mclVv(features, "features"), 40, v_));
                                }
                            }
                            if (v_2 == e_2) {
                                break;
                            }
                            ++v_2;
                        }
                        mlfAssign(&t, mlfScalar(v_2));
                    }
                }
                if (mclGtBool(
                      mclIntArrayRef2(mclVv(features, "features"), 40, v_),
                      _mxarray0_)) {
                    mclIntArrayAssign2(
                      &features,
                      mlfMean(
                        mclMinus(
                          mclArrayRef1(
                            mclVv(peak_loc, "peak_loc"),
                            mlfColon(
                              _mxarray3_,
                              mlfEnd(
                                mclVv(peak_loc, "peak_loc"),
                                _mxarray0_,
                                _mxarray0_),
                              NULL)),
                          mclArrayRef1(
                            mclVv(peak_loc, "peak_loc"),
                            mlfColon(
                              _mxarray0_,
                              mclMinus(
                                mlfEnd(
                                  mclVv(peak_loc, "peak_loc"),
                                  _mxarray0_,
                                  _mxarray0_),
                                _mxarray0_),
                              NULL))),
                        NULL),
                      41,
                      v_);
                    mclIntArrayAssign2(
                      &features,
                      mlfMean(
                        mlfAbs(
                          mclMinus(
                            mclMinus(
                              mclArrayRef1(
                                mclVv(peak_loc, "peak_loc"),
                                mlfColon(
                                  _mxarray3_,
                                  mlfEnd(
                                    mclVv(peak_loc, "peak_loc"),
                                    _mxarray0_,
                                    _mxarray0_),
                                  NULL)),
                              mclArrayRef1(
                                mclVv(peak_loc, "peak_loc"),
                                mlfColon(
                                  _mxarray0_,
                                  mclMinus(
                                    mlfEnd(
                                      mclVv(peak_loc, "peak_loc"),
                                      _mxarray0_,
                                      _mxarray0_),
                                    _mxarray0_),
                                  NULL))),
                            mclIntArrayRef2(
                              mclVv(features, "features"), 41, v_))),
                        NULL),
                      41,
                      v_);
                } else {
                    mclIntArrayAssign2(
                      &features,
                      mlfScalar(
                        svDoubleScalarRdivide(
                          (double) mclLengthInt(mclVv(fft_pow, "fft_pow")),
                          4.0)),
                      41,
                      v_);
                }
                mclIntArrayAssign2(
                  &features,
                  mclMinus(
                    mclVv(max_power, "max_power"),
                    mclVv(min_power, "min_power")),
                  42,
                  v_);
                mclIntArrayAssign2(
                  &features, mlfMean(mclVv(fft_pow, "fft_pow"), NULL), 43, v_);
                {
                    int v_3 = mclForIntStart(44);
                    int e_3 = 47;
                    if (v_3 > e_3) {
                        mlfAssign(&f, _mxarray1_);
                    } else {
                        for (; ; ) {
                            mlfAssign(
                              &i1,
                              mlfScalar(
                                svDoubleScalarPlus(
                                  svDoubleScalarTimes((double) (v_3 - 44), 4.0),
                                  1.0)));
                            mlfAssign(
                              &i2, mclPlus(mclVv(i1, "i1"), _mxarray15_));
                            mclIntArrayAssign2(
                              &features,
                              mlfMean(
                                mclArrayRef2(
                                  mclVv(coarse_fft_data, "coarse_fft_data"),
                                  mlfScalar(v_3 - 43),
                                  mlfCreateColonIndex()),
                                NULL),
                              v_3,
                              v_);
                            mclIntArrayAssign2(
                              &features,
                              mlfStd(
                                mclArrayRef2(
                                  mclVv(coarse_fft_data, "coarse_fft_data"),
                                  mlfScalar(v_3 - 43),
                                  mlfCreateColonIndex()),
                                NULL,
                                NULL),
                              v_3 + 4,
                              v_);
                            if (v_3 == e_3) {
                                break;
                            }
                            ++v_3;
                        }
                        mlfAssign(&f, mlfScalar(v_3));
                    }
                }
                mclArrayAssign2(
                  &features,
                  mlfCompute_local_features_window(
                    mclVv(fft_data, "fft_data"), mclVv(fft_pow, "fft_pow")),
                  mlfColon(_mxarray16_, _mxarray5_, NULL),
                  mlfScalar(v_));
                if (v_ == e_) {
                    break;
                }
                ++v_;
            }
            mlfAssign(&w, mlfScalar(v_));
        }
    }
    mclValidateOutput(
      features, 1, nargout_, "features", "extract_global_features_track");
    mclValidateOutput(
      *time_locations,
      2,
      nargout_,
      "time_locations",
      "extract_global_features_track");
    mclValidateOutput(
      *data_locations,
      3,
      nargout_,
      "data_locations",
      "extract_global_features_track");
    mxDestroyArray(all_fft_data);
    mxDestroyArray(all_fft_pow);
    mxDestroyArray(i);
    mxDestroyArray(all_coarse_fft_data);
    mxDestroyArray(track_length);
    mxDestroyArray(num_windows);
    mxDestroyArray(window_width_time);
    mxDestroyArray(first_window_time);
    mxDestroyArray(time_per_window);
    mxDestroyArray(w);
    mxDestroyArray(i1);
    mxDestroyArray(i2);
    mxDestroyArray(fft_data);
    mxDestroyArray(ans);
    mxDestroyArray(coarse_fft_data);
    mxDestroyArray(fft_pow);
    mxDestroyArray(tmp);
    mxDestroyArray(mpb_16);
    mxDestroyArray(mpb_4);
    mxDestroyArray(band_pow);
    mxDestroyArray(total_pow);
    mxDestroyArray(found);
    mxDestroyArray(width);
    mxDestroyArray(b);
    mxDestroyArray(num_bands_over_25);
    mxDestroyArray(min_power);
    mxDestroyArray(max_power);
    mxDestroyArray(power_70);
    mxDestroyArray(power_30);
    mxDestroyArray(had_low);
    mxDestroyArray(had_high);
    mxDestroyArray(t);
    mxDestroyArray(curr_state);
    mxDestroyArray(peak_loc);
    mxDestroyArray(f);
    mxDestroyArray(search_params);
    mxDestroyArray(fft_params);
    mxDestroyArray(data);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return features;
    /*
     * 
     * 
     * 
     * 
     */
}
