

#define WAV_DATA "wav_data"
#define WAV_NSAMPLES "wav_nsamples"

/**
 * Read the wave data and converts to floating point format.  Assumes uncompressed
 * PCM format, 16 bit, 8000 fs (no header reading).  
 * lf_obj_handle_t points to the wav file object
 * data points to the data pointer
 * len is the number of samples
 */
int fread_wav_data(lf_obj_handle_t ohandle, double** data, int* len);
	
/**
 * Calls above and writes to WAV_DATA and WAV_NSAMPLES attributes
 */      
int f_init_readwav(int numarg, char** args, int blob_len,
		   void* blob, void** f_datap);
int f_eval_readwav(lf_obj_handle_t ohandle, int numout, 
		   lf_obj_handle_t *ohandles, void *f_datap); 
int f_fini_readwav(void* f_datap);
