/*
 * MATLAB Compiler: 3.0
 * Date: Wed Aug 25 13:39:08 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-W" "main" "-L" "C"
 * "-t" "-T" "link:lib" "-h" "test_track" "libmmfile.mlib" "-v" 
 */
#include "makeblocks.h"
#include "libmatlbm.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;

void InitializeModule_makeblocks(void) {
    _mxarray0_ = mclInitializeDouble(1.0);
    _mxarray1_ = mclInitializeDouble(0.0);
}

void TerminateModule_makeblocks(void) {
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mmakeblocks(int nargout_,
                             mxArray * wav,
                             mxArray * blocksize,
                             mxArray * n);

_mexLocalFunctionTable _local_function_table_makeblocks
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfMakeblocks" contains the normal interface for the
 * "makeblocks" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/makeblocks.m" (lines 1-34). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfMakeblocks(mxArray * wav, mxArray * blocksize, mxArray * n) {
    int nargout = 1;
    mxArray * blocks = NULL;
    mlfEnterNewContext(0, 3, wav, blocksize, n);
    blocks = Mmakeblocks(nargout, wav, blocksize, n);
    mlfRestorePreviousContext(0, 3, wav, blocksize, n);
    return mlfReturnValue(blocks);
}

/*
 * The function "mlxMakeblocks" contains the feval interface for the
 * "makeblocks" M-function from file
 * "/afs/cs.cmu.edu/user/dhoiem/code_for_c/makeblocks.m" (lines 1-34). The
 * feval function calls the implementation version of makeblocks through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxMakeblocks(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: makeblocks Line: 4 Column:"
            " 1 The function \"makeblocks\" was called with m"
            "ore than the declared number of outputs (1)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: makeblocks Line: 4 Column"
            ": 1 The function \"makeblocks\" was called with"
            " more than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mmakeblocks(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mmakeblocks" is the implementation version of the "makeblocks"
 * M-function from file "/afs/cs.cmu.edu/user/dhoiem/code_for_c/makeblocks.m"
 * (lines 1-34). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * % Make overlapping blocks, each with blocksize and overlapping n-1/n
 * % Only generate starting indices
 * % 
 * function blocks = makeblocks(wav, blocksize, n)
 */
static mxArray * Mmakeblocks(int nargout_,
                             mxArray * wav,
                             mxArray * blocksize,
                             mxArray * n) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_makeblocks);
    mxArray * blocks = NULL;
    mxArray * numblocks = NULL;
    mclCopyArray(&wav);
    mclCopyArray(&blocksize);
    mclCopyArray(&n);
    /*
     * 
     * % crop any extra stuff at end
     * numblocks = floor((length(wav)/blocksize - 1)*n);
     */
    mlfAssign(
      &numblocks,
      mlfFloor(
        mclMtimes(
          mclMinus(
            mclMrdivide(
              mlfScalar(mclLengthInt(mclVa(wav, "wav"))),
              mclVa(blocksize, "blocksize")),
            _mxarray0_),
          mclVa(n, "n"))));
    /*
     * 
     * blocks = floor((0:numblocks)*(blocksize/n)+1);
     */
    mlfAssign(
      &blocks,
      mlfFloor(
        mclPlus(
          mclMtimes(
            mlfColon(_mxarray1_, mclVv(numblocks, "numblocks"), NULL),
            mclMrdivide(mclVa(blocksize, "blocksize"), mclVa(n, "n"))),
          _mxarray0_)));
    mclValidateOutput(blocks, 1, nargout_, "blocks", "makeblocks");
    mxDestroyArray(numblocks);
    mxDestroyArray(n);
    mxDestroyArray(blocksize);
    mxDestroyArray(wav);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return blocks;
    /*
     * return;
     * 
     * 
     * % if (round(blocksize / n) * n == blocksize)
     * %   blocks = 1 : (blocksize / n) : (numblocks* blocksize)
     * %   blocks = blocks';
     * % else
     * % 
     * % % if blocksize / n isn't an integer
     * % 
     * % hblocks = 0:(n-1);
     * % hblocks = round(hblocks .* blocksize ./ n);
     * % hblocks = repmat(hblocks, numblocks, 1);
     * % 
     * % vblocks = 0:(numblocks-1);
     * % vblocks = vblocks .* blocksize;
     * % vblocks = vblocks';
     * % vblocks = repmat(vblocks, 1, n);
     * % 
     * % tblocks = vblocks + hblocks;
     * % 
     * % blocks = reshape(tblocks', n * numblocks, 1) + 1;
     * % 
     * % end
     */
}
